//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class AdminApi {
  AdminApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Lists the Database schema updates already installed
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lists the Database schema updates already installed.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b>DbUpdate</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> adminAppliedUpdatesWithHttpInfo(String region,) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/admin/schema/AppliedUpdates"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Lists the Database schema updates already installed
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lists the Database schema updates already installed.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b>DbUpdate</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<List<DbUpdate>> adminAppliedUpdates(String region,) async {
    final response = await adminAppliedUpdatesWithHttpInfo(region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<DbUpdate>') as List)
        .cast<DbUpdate>()
        .toList(growable: false);

    }
    return Future<List<DbUpdate>>.value();
  }

  /// Flushes the Flex caches
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Flushes the Flex caches.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> adminFlushCachesWithHttpInfo(String region,) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/admin/schema/FlushCaches"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Flushes the Flex caches
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Flushes the Flex caches.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<void> adminFlushCaches(String region,) async {
    final response = await adminFlushCachesWithHttpInfo(region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Returns a flag indicating if the database schema requires an upgrade
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns a flag indicating if the database schema requires an upgrade.<br/>This service can be used by any client. SuperUser role is not required.<br/>Return Type: <b>boolean</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> adminGetIsCurrentWithHttpInfo(String region,) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/admin/schema/IsCurrent"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Returns a flag indicating if the database schema requires an upgrade
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns a flag indicating if the database schema requires an upgrade.<br/>This service can be used by any client. SuperUser role is not required.<br/>Return Type: <b>boolean</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<bool> adminGetIsCurrent(String region,) async {
    final response = await adminGetIsCurrentWithHttpInfo(region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'bool',) as bool;
    
    }
    return Future<bool>.value();
  }

  /// Lists the Database schema updates required
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lists the Database schema updates required.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b>DbUpdate</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> adminPendingUpdatesWithHttpInfo(String region,) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/admin/schema/PendingUpdates"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Lists the Database schema updates required
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lists the Database schema updates required.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b>DbUpdate</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<List<DbUpdate>> adminPendingUpdates(String region,) async {
    final response = await adminPendingUpdatesWithHttpInfo(region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      final responseBody = await _decodeBodyBytes(response);
      return (await apiClient.deserializeAsync(responseBody, 'List<DbUpdate>') as List)
        .cast<DbUpdate>()
        .toList(growable: false);

    }
    return Future<List<DbUpdate>>.value();
  }

  /// Updates the Database schemas to the latest version
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Updates the Database schemas to the latest version.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> adminUpdateSchemaWithHttpInfo(String region,) async {
    // Verify required params are set.
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/admin/schema/UpdateSchema"
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Updates the Database schemas to the latest version
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Updates the Database schemas to the latest version.<br/>This can only be used by users in the Flex Superuser role.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<void> adminUpdateSchema(String region,) async {
    final response = await adminUpdateSchemaWithHttpInfo(region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }
}
