//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class DocumentFilesApi {
  DocumentFilesApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Downloads binary file related to asset and model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Downloads binary file related to asset and model.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   Asset ID
  ///
  /// * [int] modelId (required):
  ///   Model ID
  ///
  /// * [String] fileId (required):
  ///   File ID
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> documentFilesGetFileWithHttpInfo(int assetId, int modelId, String fileId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (fileId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: fileId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/documentfiles/download/{assetId}/{modelId}/{fileId}"
      .replaceAll('{assetId}', assetId.toString())
      .replaceAll('{modelId}', modelId.toString())
      .replaceAll('{fileId}', fileId)
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Downloads binary file related to asset and model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Downloads binary file related to asset and model.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   Asset ID
  ///
  /// * [int] modelId (required):
  ///   Model ID
  ///
  /// * [String] fileId (required):
  ///   File ID
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> documentFilesGetFile(int assetId, int modelId, String fileId, String tenantId, String region,) async {
    final response = await documentFilesGetFileWithHttpInfo(assetId, modelId, fileId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Uploads a document file related to a specific model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Uploads a document file related to a specific model.<br/>The document will be associated with the asset and model provided in the Form data parameters.<br/>Return Type: <b>FileUploadResult</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   An arbitrary document which will get associated to the model or its parts.
  ///
  /// * [String] documentName (required):
  ///   The name of the Document
  ///
  /// * [int] assetId (required):
  ///   Asset which should contain the document
  ///
  /// * [int] modelId (required):
  ///   Asset model which should contain the document
  ///
  /// * [String] externalId:
  ///   External identity of the document. This will be used for versioning.
  Future<Response> documentFilesUploadSingleFileWithHttpInfo(String tenantId, String region, MultipartFile file, String documentName, int assetId, int modelId, { String externalId, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (file == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: file');
    }
    if (documentName == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: documentName');
    }
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/documentfiles/upload"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['multipart/form-data'];

    bool hasFields = false;
    final mp = MultipartRequest('POST', Uri.parse(path));
    if (file != null) {
      hasFields = true;
      mp.fields[r'file'] = file.field;
      mp.files.add(file);
    }
    if (documentName != null) {
      hasFields = true;
      mp.fields[r'documentName'] = parameterToString(documentName);
    }
    if (assetId != null) {
      hasFields = true;
      mp.fields[r'assetId'] = parameterToString(assetId);
    }
    if (modelId != null) {
      hasFields = true;
      mp.fields[r'modelId'] = parameterToString(modelId);
    }
    if (externalId != null) {
      hasFields = true;
      mp.fields[r'externalId'] = parameterToString(externalId);
    }
    if (hasFields) {
      postBody = mp;
    }

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Uploads a document file related to a specific model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Uploads a document file related to a specific model.<br/>The document will be associated with the asset and model provided in the Form data parameters.<br/>Return Type: <b>FileUploadResult</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   An arbitrary document which will get associated to the model or its parts.
  ///
  /// * [String] documentName (required):
  ///   The name of the Document
  ///
  /// * [int] assetId (required):
  ///   Asset which should contain the document
  ///
  /// * [int] modelId (required):
  ///   Asset model which should contain the document
  ///
  /// * [String] externalId:
  ///   External identity of the document. This will be used for versioning.
  Future<FileUploadResult> documentFilesUploadSingleFile(String tenantId, String region, MultipartFile file, String documentName, int assetId, int modelId, { String externalId, }) async {
    final response = await documentFilesUploadSingleFileWithHttpInfo(tenantId, region, file, documentName, assetId, modelId,  externalId: externalId, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'FileUploadResult',) as FileUploadResult;
    
    }
    return Future<FileUploadResult>.value();
  }
}
