//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class EntitiesApi {
  EntitiesApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Adds a new document to a model entity
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Adds a new document to a model entity.<br/>Return Type: <b>Document</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model Id
  ///
  /// * [int] entityId (required):
  ///   The unique identifier for the target entity (Entity Label)
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [DocumentCreate] documentCreate (required):
  ///   A document to create
  Future<Response> entitiesAddDocumentByAssetmodelidAndEntityidAndTenantidWithHttpInfo(int assetModelId, int entityId, String tenantId, String region, DocumentCreate documentCreate,) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (documentCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: documentCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities(AssetModelId={assetModelId}, EntityId={entityId})/DocumentEntities"
      .replaceAll('{assetModelId}', assetModelId.toString())
      .replaceAll('{entityId}', entityId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = documentCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Adds a new document to a model entity
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Adds a new document to a model entity.<br/>Return Type: <b>Document</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model Id
  ///
  /// * [int] entityId (required):
  ///   The unique identifier for the target entity (Entity Label)
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [DocumentCreate] documentCreate (required):
  ///   A document to create
  Future<Document> entitiesAddDocumentByAssetmodelidAndEntityidAndTenantid(int assetModelId, int entityId, String tenantId, String region, DocumentCreate documentCreate,) async {
    final response = await entitiesAddDocumentByAssetmodelidAndEntityidAndTenantidWithHttpInfo(assetModelId, entityId, tenantId, region, documentCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Document',) as Document;
    
    }
    return Future<Document>.value();
  }

  /// Get Entities as of by date and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [DateTime] date (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> entitiesAsOfByDateAndTenantidWithHttpInfo(DateTime date, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (date == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: date');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities/AsOf(date={date})"
      .replaceAll('{date}', date.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Entities as of by date and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [DateTime] date (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfEntity> entitiesAsOfByDateAndTenantid(DateTime date, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await entitiesAsOfByDateAndTenantidWithHttpInfo(date, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfEntity',) as ODataListResponseOfEntity;
    
    }
    return Future<ODataListResponseOfEntity>.value();
  }

  /// Query a set of Entities at a point in time
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Query a set of Entities at a point in time.<br/>Service allows consumers to interogate the state of entities at any point in the history by specifying a date to view the results at<br />              Note that casting is not currently supported..<br/>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [DateTime] date (required):
  ///   The Date to view the entites at
  ///
  /// * [String] entityKind (required):
  ///   The kind of entity to return
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> entitiesAsOfByKindWithHttpInfo(DateTime date, String entityKind, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (date == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: date');
    }
    if (entityKind == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityKind');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities/AsOf(date={date},entityKind={entityKind})"
      .replaceAll('{date}', date.toString())
      .replaceAll('{entityKind}', entityKind)
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Query a set of Entities at a point in time
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Query a set of Entities at a point in time.<br/>Service allows consumers to interogate the state of entities at any point in the history by specifying a date to view the results at<br />              Note that casting is not currently supported..<br/>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [DateTime] date (required):
  ///   The Date to view the entites at
  ///
  /// * [String] entityKind (required):
  ///   The kind of entity to return
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfEntity> entitiesAsOfByKind(DateTime date, String entityKind, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await entitiesAsOfByKindWithHttpInfo(date, entityKind, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfEntity',) as ODataListResponseOfEntity;
    
    }
    return Future<ODataListResponseOfEntity>.value();
  }

  /// Gets the Properties available on this Model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the Properties available on this Model.<br/>Return Type: <b>ODataListResponseOfAttributeDefinition</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The unique key for the asset
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> entitiesGetAvailablePropertiesByAssetidAndTenantidWithHttpInfo(int assetId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities/GetAvailableProperties(assetId={assetId})"
      .replaceAll('{assetId}', assetId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the Properties available on this Model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the Properties available on this Model.<br/>Return Type: <b>ODataListResponseOfAttributeDefinition</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The unique key for the asset
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfAttributeDefinition> entitiesGetAvailablePropertiesByAssetidAndTenantid(int assetId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await entitiesGetAvailablePropertiesByAssetidAndTenantidWithHttpInfo(assetId, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfAttributeDefinition',) as ODataListResponseOfAttributeDefinition;
    
    }
    return Future<ODataListResponseOfAttributeDefinition>.value();
  }

  /// Returns the EntitySet Entities
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Entities.<br/>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> entitiesGetByTenantidWithHttpInfo(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Returns the EntitySet Entities
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Entities.<br/>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfEntity> entitiesGetByTenantid(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await entitiesGetByTenantidWithHttpInfo(tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfEntity',) as ODataListResponseOfEntity;
    
    }
    return Future<ODataListResponseOfEntity>.value();
  }

  /// Get Entities single entity by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Response> entitiesGetSingleEntityByAssetmodelidAndEntityidAndTenantidWithHttpInfo(int assetModelId, int entityId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities(AssetModelId={assetModelId}, EntityId={entityId})"
      .replaceAll('{assetModelId}', assetModelId.toString())
      .replaceAll('{entityId}', entityId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Entities single entity by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Entity> entitiesGetSingleEntityByAssetmodelidAndEntityidAndTenantid(int assetModelId, int entityId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    final response = await entitiesGetSingleEntityByAssetmodelidAndEntityidAndTenantidWithHttpInfo(assetModelId, entityId, tenantId, region,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Entity',) as Entity;
    
    }
    return Future<Entity>.value();
  }

  /// Provides the xbim flex identities for a set of provided IfcGuids
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Provides the xbim flex identities for a set of provided IfcGuids.<br/>Typically used to map from external Guids in BCF files to the best internal candidates in Flex.<br/>Return Type: <b>ODataListResponseOfEntityRef</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  ///
  /// * [InlineObject4] inlineObject4:
  Future<Response> entitiesLookupByTenantidWithHttpInfo(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, InlineObject4 inlineObject4, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities/Guids.Lookup"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = inlineObject4;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Provides the xbim flex identities for a set of provided IfcGuids
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Provides the xbim flex identities for a set of provided IfcGuids.<br/>Typically used to map from external Guids in BCF files to the best internal candidates in Flex.<br/>Return Type: <b>ODataListResponseOfEntityRef</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  ///
  /// * [InlineObject4] inlineObject4:
  Future<ODataListResponseOfEntityRef> entitiesLookupByTenantid(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, InlineObject4 inlineObject4, }) async {
    final response = await entitiesLookupByTenantidWithHttpInfo(tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, inlineObject4: inlineObject4, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfEntityRef',) as ODataListResponseOfEntityRef;
    
    }
    return Future<ODataListResponseOfEntityRef>.value();
  }

  /// Patch Entities by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [EntityEdit] entityEdit (required):
  Future<Response> entitiesPatchByAssetmodelidAndEntityidAndTenantidWithHttpInfo(int assetModelId, int entityId, String tenantId, String region, EntityEdit entityEdit,) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (entityEdit == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityEdit');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities(AssetModelId={AssetModelId}, EntityId={EntityId})"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{EntityId}', entityId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = entityEdit;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Patch Entities by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [EntityEdit] entityEdit (required):
  Future<Entity> entitiesPatchByAssetmodelidAndEntityidAndTenantid(int assetModelId, int entityId, String tenantId, String region, EntityEdit entityEdit,) async {
    final response = await entitiesPatchByAssetmodelidAndEntityidAndTenantidWithHttpInfo(assetModelId, entityId, tenantId, region, entityEdit,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Entity',) as Entity;
    
    }
    return Future<Entity>.value();
  }

  /// Post a new entity to EntitySet Entities
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Post a new entity to EntitySet Entities.<br/>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [EntityCreate] entityCreate (required):
  ///   The entity to post
  Future<Response> entitiesPostByTenantidWithHttpInfo(String tenantId, String region, EntityCreate entityCreate,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (entityCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Entities"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = entityCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post a new entity to EntitySet Entities
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Post a new entity to EntitySet Entities.<br/>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [EntityCreate] entityCreate (required):
  ///   The entity to post
  Future<Entity> entitiesPostByTenantid(String tenantId, String region, EntityCreate entityCreate,) async {
    final response = await entitiesPostByTenantidWithHttpInfo(tenantId, region, entityCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Entity',) as Entity;
    
    }
    return Future<Entity>.value();
  }
}
