//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class FloorplansApi {
  FloorplansApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Gets floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [SvgGenerationConfig] svgGenerationConfig (required):
  Future<Response> floorplansGetFloorPlanWithHttpInfo(String tenantId, int assetModelId, int entityId, String region, SvgGenerationConfig svgGenerationConfig,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (svgGenerationConfig == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: svgGenerationConfig');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/floorplans/level/{assetModelId}/{entityId}"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{assetModelId}', assetModelId.toString())
      .replaceAll('{entityId}', entityId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = svgGenerationConfig;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [SvgGenerationConfig] svgGenerationConfig (required):
  Future<MultipartFile> floorplansGetFloorPlan(String tenantId, int assetModelId, int entityId, String region, SvgGenerationConfig svgGenerationConfig,) async {
    final response = await floorplansGetFloorPlanWithHttpInfo(tenantId, assetModelId, entityId, region, svgGenerationConfig,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets space floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets space floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [SvgGenerationConfig] svgGenerationConfig (required):
  Future<Response> floorplansGetSpaceFloorPlanWithHttpInfo(String tenantId, int assetModelId, int entityId, String region, SvgGenerationConfig svgGenerationConfig,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (svgGenerationConfig == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: svgGenerationConfig');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/floorplans/space/{assetModelId}/{entityId}"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{assetModelId}', assetModelId.toString())
      .replaceAll('{entityId}', entityId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = svgGenerationConfig;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json', 'text/json', 'application/xml', 'text/xml', 'application/x-www-form-urlencoded'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets space floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets space floor plan as SVG image. Element of SVG have encoded identity allowing to implement custom interactions  where more data can be retrieved from Flex API.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [SvgGenerationConfig] svgGenerationConfig (required):
  Future<MultipartFile> floorplansGetSpaceFloorPlan(String tenantId, int assetModelId, int entityId, String region, SvgGenerationConfig svgGenerationConfig,) async {
    final response = await floorplansGetSpaceFloorPlanWithHttpInfo(tenantId, assetModelId, entityId, region, svgGenerationConfig,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }
}
