//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class JobsApi {
  JobsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Adds a new document to a model entity
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Adds a new document to a model entity.<br/>Return Type: <b>Document</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model Id
  ///
  /// * [int] entityId (required):
  ///   The unique identifier for the target entity (Entity Label)
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [DocumentCreate] documentCreate (required):
  ///   A document to create
  Future<Response> jobsAddDocumentByAssetmodelidAndEntityidAndTenantidWithHttpInfo(int assetModelId, int entityId, String tenantId, String region, DocumentCreate documentCreate,) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (documentCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: documentCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Jobs(AssetModelId={assetModelId}, EntityId={entityId})/DocumentEntities"
      .replaceAll('{assetModelId}', assetModelId.toString())
      .replaceAll('{entityId}', entityId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = documentCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Adds a new document to a model entity
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Adds a new document to a model entity.<br/>Return Type: <b>Document</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model Id
  ///
  /// * [int] entityId (required):
  ///   The unique identifier for the target entity (Entity Label)
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [DocumentCreate] documentCreate (required):
  ///   A document to create
  Future<Document> jobsAddDocumentByAssetmodelidAndEntityidAndTenantid(int assetModelId, int entityId, String tenantId, String region, DocumentCreate documentCreate,) async {
    final response = await jobsAddDocumentByAssetmodelidAndEntityidAndTenantidWithHttpInfo(assetModelId, entityId, tenantId, region, documentCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Document',) as Document;
    
    }
    return Future<Document>.value();
  }

  /// Get Jobs as of by date and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [DateTime] date (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> jobsAsOfByDateAndTenantidWithHttpInfo(DateTime date, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (date == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: date');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Jobs/AsOf(date={date})"
      .replaceAll('{date}', date.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Jobs as of by date and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ODataListResponseOfEntity</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [DateTime] date (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfEntity> jobsAsOfByDateAndTenantid(DateTime date, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await jobsAsOfByDateAndTenantidWithHttpInfo(date, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfEntity',) as ODataListResponseOfEntity;
    
    }
    return Future<ODataListResponseOfEntity>.value();
  }

  /// Gets the Properties available on this Model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the Properties available on this Model.<br/>Return Type: <b>ODataListResponseOfAttributeDefinition</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The unique key for the asset
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> jobsGetAvailablePropertiesByAssetidAndTenantidWithHttpInfo(int assetId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Jobs/GetAvailableProperties(assetId={assetId})"
      .replaceAll('{assetId}', assetId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the Properties available on this Model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the Properties available on this Model.<br/>Return Type: <b>ODataListResponseOfAttributeDefinition</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The unique key for the asset
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfAttributeDefinition> jobsGetAvailablePropertiesByAssetidAndTenantid(int assetId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await jobsGetAvailablePropertiesByAssetidAndTenantidWithHttpInfo(assetId, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfAttributeDefinition',) as ODataListResponseOfAttributeDefinition;
    
    }
    return Future<ODataListResponseOfAttributeDefinition>.value();
  }

  /// Returns the EntitySet Jobs
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Jobs.<br/>Return Type: <b>ODataListResponseOfJob</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> jobsGetByTenantidWithHttpInfo(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Jobs"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Returns the EntitySet Jobs
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Jobs.<br/>Return Type: <b>ODataListResponseOfJob</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfJob> jobsGetByTenantid(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await jobsGetByTenantidWithHttpInfo(tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfJob',) as ODataListResponseOfJob;
    
    }
    return Future<ODataListResponseOfJob>.value();
  }

  /// Get Jobs single entity by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Job</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Response> jobsGetSingleEntityByAssetmodelidAndEntityidAndTenantidWithHttpInfo(int assetModelId, int entityId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Jobs(AssetModelId={assetModelId}, EntityId={entityId})"
      .replaceAll('{assetModelId}', assetModelId.toString())
      .replaceAll('{entityId}', entityId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Jobs single entity by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Job</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Job> jobsGetSingleEntityByAssetmodelidAndEntityidAndTenantid(int assetModelId, int entityId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    final response = await jobsGetSingleEntityByAssetmodelidAndEntityidAndTenantidWithHttpInfo(assetModelId, entityId, tenantId, region,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Job',) as Job;
    
    }
    return Future<Job>.value();
  }

  /// Patch Jobs by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [JobEdit] jobEdit (required):
  Future<Response> jobsPatchByAssetmodelidAndEntityidAndTenantidWithHttpInfo(int assetModelId, int entityId, String tenantId, String region, JobEdit jobEdit,) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (entityId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: entityId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (jobEdit == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: jobEdit');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Jobs(AssetModelId={AssetModelId}, EntityId={EntityId})"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{EntityId}', entityId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = jobEdit;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Patch Jobs by assetmodelid, entityid and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [int] entityId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [JobEdit] jobEdit (required):
  Future<Entity> jobsPatchByAssetmodelidAndEntityidAndTenantid(int assetModelId, int entityId, String tenantId, String region, JobEdit jobEdit,) async {
    final response = await jobsPatchByAssetmodelidAndEntityidAndTenantidWithHttpInfo(assetModelId, entityId, tenantId, region, jobEdit,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Entity',) as Entity;
    
    }
    return Future<Entity>.value();
  }

  /// Post a new entity to EntitySet Jobs
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Post a new entity to EntitySet Jobs.<br/>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [JobCreate] jobCreate (required):
  ///   The entity to post
  Future<Response> jobsPostByTenantidWithHttpInfo(String tenantId, String region, JobCreate jobCreate,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (jobCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: jobCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Jobs"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = jobCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post a new entity to EntitySet Jobs
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Post a new entity to EntitySet Jobs.<br/>Return Type: <b>Entity</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [JobCreate] jobCreate (required):
  ///   The entity to post
  Future<Entity> jobsPostByTenantid(String tenantId, String region, JobCreate jobCreate,) async {
    final response = await jobsPostByTenantidWithHttpInfo(tenantId, region, jobCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Entity',) as Entity;
    
    }
    return Future<Entity>.value();
  }
}
