//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class ModelFilesApi {
  ModelFilesApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Downloads the model as originally uploaded
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Downloads the model as originally uploaded.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   Asset ID
  ///
  /// * [int] modelId (required):
  ///   Model ID
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> modelFilesGetFileWithHttpInfo(int assetId, int modelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/modelfiles/download/{assetId}/{modelId}"
      .replaceAll('{assetId}', assetId.toString())
      .replaceAll('{modelId}', modelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Downloads the model as originally uploaded
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Downloads the model as originally uploaded.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   Asset ID
  ///
  /// * [int] modelId (required):
  ///   Model ID
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> modelFilesGetFile(int assetId, int modelId, String tenantId, String region,) async {
    final response = await modelFilesGetFileWithHttpInfo(assetId, modelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// A one-stop service for Uploading an IFC model file, creating an asset and Model as required, and initiating processing
  ///
  /// <span style='font-size: 17px;'>Summary:</span>A one-stop service for Uploading an IFC model file, creating an asset and Model as required, and initiating processing.<br/>Uploads a model File, creating a new Asset and Model as required.  The model is associated with the named asset. The Asset will be created if it does not exist.  <br />  On successful upload the model will be queued for processing..<br/>Return Type: <b>FileUploadResult</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   A model file in the correct format (IFC / IFCZip / Zip)
  ///
  /// * [String] assetName (required):
  ///   The name of the asset to associate the model upload with.
  ///
  /// * [String] segmentName:
  ///   The name of the asset segment to associate the model with. The segment will be created if not present. Defaults to the Model Name if undefined
  ///
  /// * [String] revision:
  ///   A version identifier for the model.
  ///
  /// * [String] status:
  ///   A status identifier for the model
  ///
  /// * [int] assetId:
  ///   The ID of the asset to associate the model upload with. If not defined, a new asset will be created.
  ///
  /// * [int] modelId:
  ///   The ID of the model to be populated with the data. If not defined, a new model will be created.
  ///
  /// * [String] originalFilename:
  ///   The original filename of the model, for zipped models
  Future<Response> modelFilesUploadSingleFileWithHttpInfo(String tenantId, String region, MultipartFile file, String assetName, { String segmentName, String revision, String status, int assetId, int modelId, String originalFilename, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (file == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: file');
    }
    if (assetName == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetName');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/modelfiles/upload"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['multipart/form-data'];

    bool hasFields = false;
    final mp = MultipartRequest('POST', Uri.parse(path));
    if (file != null) {
      hasFields = true;
      mp.fields[r'file'] = file.field;
      mp.files.add(file);
    }
    if (assetName != null) {
      hasFields = true;
      mp.fields[r'assetName'] = parameterToString(assetName);
    }
    if (segmentName != null) {
      hasFields = true;
      mp.fields[r'segmentName'] = parameterToString(segmentName);
    }
    if (revision != null) {
      hasFields = true;
      mp.fields[r'revision'] = parameterToString(revision);
    }
    if (status != null) {
      hasFields = true;
      mp.fields[r'status'] = parameterToString(status);
    }
    if (assetId != null) {
      hasFields = true;
      mp.fields[r'assetId'] = parameterToString(assetId);
    }
    if (modelId != null) {
      hasFields = true;
      mp.fields[r'modelId'] = parameterToString(modelId);
    }
    if (originalFilename != null) {
      hasFields = true;
      mp.fields[r'originalFilename'] = parameterToString(originalFilename);
    }
    if (hasFields) {
      postBody = mp;
    }

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// A one-stop service for Uploading an IFC model file, creating an asset and Model as required, and initiating processing
  ///
  /// <span style='font-size: 17px;'>Summary:</span>A one-stop service for Uploading an IFC model file, creating an asset and Model as required, and initiating processing.<br/>Uploads a model File, creating a new Asset and Model as required.  The model is associated with the named asset. The Asset will be created if it does not exist.  <br />  On successful upload the model will be queued for processing..<br/>Return Type: <b>FileUploadResult</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   A model file in the correct format (IFC / IFCZip / Zip)
  ///
  /// * [String] assetName (required):
  ///   The name of the asset to associate the model upload with.
  ///
  /// * [String] segmentName:
  ///   The name of the asset segment to associate the model with. The segment will be created if not present. Defaults to the Model Name if undefined
  ///
  /// * [String] revision:
  ///   A version identifier for the model.
  ///
  /// * [String] status:
  ///   A status identifier for the model
  ///
  /// * [int] assetId:
  ///   The ID of the asset to associate the model upload with. If not defined, a new asset will be created.
  ///
  /// * [int] modelId:
  ///   The ID of the model to be populated with the data. If not defined, a new model will be created.
  ///
  /// * [String] originalFilename:
  ///   The original filename of the model, for zipped models
  Future<FileUploadResult> modelFilesUploadSingleFile(String tenantId, String region, MultipartFile file, String assetName, { String segmentName, String revision, String status, int assetId, int modelId, String originalFilename, }) async {
    final response = await modelFilesUploadSingleFileWithHttpInfo(tenantId, region, file, assetName,  segmentName: segmentName, revision: revision, status: status, assetId: assetId, modelId: modelId, originalFilename: originalFilename, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'FileUploadResult',) as FileUploadResult;
    
    }
    return Future<FileUploadResult>.value();
  }
}
