//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class ModelsApi {
  ModelsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Assigns a user to the given role on the model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Assigns a user to the given role on the model.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [InlineObject6] inlineObject6 (required):
  Future<Response> modelsAssignByTenantidAndAssetmodelidWithHttpInfo(String tenantId, int assetModelId, String region, InlineObject6 inlineObject6,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (inlineObject6 == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: inlineObject6');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/Roles.Assign"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = inlineObject6;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Assigns a user to the given role on the model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Assigns a user to the given role on the model.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [InlineObject6] inlineObject6 (required):
  Future<void> modelsAssignByTenantidAndAssetmodelid(String tenantId, int assetModelId, String region, InlineObject6 inlineObject6,) async {
    final response = await modelsAssignByTenantidAndAssetmodelidWithHttpInfo(tenantId, assetModelId, region, inlineObject6,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Archive a model for future deletion
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Archive a model for future deletion.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   key: AssetModelId
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] ifMatch:
  ///   If-Match header
  Future<Response> modelsDeleteByAssetmodelidAndTenantidWithHttpInfo(int assetModelId, String tenantId, String region, { String ifMatch, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (ifMatch != null) {
      headerParams[r'If-Match'] = parameterToString(ifMatch);
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'DELETE',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Archive a model for future deletion
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Archive a model for future deletion.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   key: AssetModelId
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] ifMatch:
  ///   If-Match header
  Future<void> modelsDeleteByAssetmodelidAndTenantid(int assetModelId, String tenantId, String region, { String ifMatch, }) async {
    final response = await modelsDeleteByAssetmodelidAndTenantidWithHttpInfo(assetModelId, tenantId, region,  ifMatch: ifMatch, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Generates a model mappings between two distinct models
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Generates a model mappings between two distinct models.<br/>Return Type: <b>ODataListResponseOfModelMappingReport</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model ID to baseline
  ///
  /// * [int] targetModelId (required):
  ///   The latest Model ID to compare against
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> modelsGenerateModelMappingByAssetmodelidAndTargetmodelidAndTenantidWithHttpInfo(int assetModelId, int targetModelId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (targetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: targetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/GenerateModelMapping(id={targetModelId})"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{targetModelId}', targetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Generates a model mappings between two distinct models
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Generates a model mappings between two distinct models.<br/>Return Type: <b>ODataListResponseOfModelMappingReport</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model ID to baseline
  ///
  /// * [int] targetModelId (required):
  ///   The latest Model ID to compare against
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfModelMappingReport> modelsGenerateModelMappingByAssetmodelidAndTargetmodelidAndTenantid(int assetModelId, int targetModelId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await modelsGenerateModelMappingByAssetmodelidAndTargetmodelidAndTenantidWithHttpInfo(assetModelId, targetModelId, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfModelMappingReport',) as ODataListResponseOfModelMappingReport;
    
    }
    return Future<ODataListResponseOfModelMappingReport>.value();
  }

  /// Returns the EntitySet Models
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Models.<br/>Return Type: <b>ODataListResponseOfModel</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> modelsGetByTenantidWithHttpInfo(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Returns the EntitySet Models
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Models.<br/>Return Type: <b>ODataListResponseOfModel</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfModel> modelsGetByTenantid(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await modelsGetByTenantidWithHttpInfo(tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfModel',) as ODataListResponseOfModel;
    
    }
    return Future<ODataListResponseOfModel>.value();
  }

  /// Returns the entity with the key from Models
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the entity with the key from Models.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   key: AssetModelId
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Response> modelsGetSingleByAssetmodelidAndTenantidWithHttpInfo(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Returns the entity with the key from Models
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the entity with the key from Models.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   key: AssetModelId
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Model> modelsGetSingleByAssetmodelidAndTenantid(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    final response = await modelsGetSingleByAssetmodelidAndTenantidWithHttpInfo(assetModelId, tenantId, region,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Model',) as Model;
    
    }
    return Future<Model>.value();
  }

  /// Gets the list of users with access to this model and their permissions
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the list of users with access to this model and their permissions.<br/>Return Type: <b>ODataListResponseOfMemberPermission</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> modelsMemberAccessByAssetmodelidAndTenantidWithHttpInfo(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/MemberAccess"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the list of users with access to this model and their permissions
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the list of users with access to this model and their permissions.<br/>Return Type: <b>ODataListResponseOfMemberPermission</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfMemberPermission> modelsMemberAccessByAssetmodelidAndTenantid(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await modelsMemberAccessByAssetmodelidAndTenantidWithHttpInfo(assetModelId, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfMemberPermission',) as ODataListResponseOfMemberPermission;
    
    }
    return Future<ODataListResponseOfMemberPermission>.value();
  }

  /// Move a model to another asset in this tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Move a model to another asset in this tenant.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///   The Model ID
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [InlineObject5] inlineObject5 (required):
  Future<Response> modelsMoveByTenantidAndAssetmodelidWithHttpInfo(String tenantId, int assetModelId, String region, InlineObject5 inlineObject5,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (inlineObject5 == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: inlineObject5');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/Asset.Move"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = inlineObject5;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Move a model to another asset in this tenant
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Move a model to another asset in this tenant.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///   The Model ID
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [InlineObject5] inlineObject5 (required):
  Future<Model> modelsMoveByTenantidAndAssetmodelid(String tenantId, int assetModelId, String region, InlineObject5 inlineObject5,) async {
    final response = await modelsMoveByTenantidAndAssetmodelidWithHttpInfo(tenantId, assetModelId, region, inlineObject5,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Model',) as Model;
    
    }
    return Future<Model>.value();
  }

  /// Edit an existing model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Edit an existing model.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ModelEdit] modelEdit (required):
  ///   The entity to patch
  Future<Response> modelsPatchByAssetmodelidAndTenantidWithHttpInfo(int assetModelId, String tenantId, String region, ModelEdit modelEdit,) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (modelEdit == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelEdit');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = modelEdit;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'PATCH',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Edit an existing model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Edit an existing model.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ModelEdit] modelEdit (required):
  ///   The entity to patch
  Future<Model> modelsPatchByAssetmodelidAndTenantid(int assetModelId, String tenantId, String region, ModelEdit modelEdit,) async {
    final response = await modelsPatchByAssetmodelidAndTenantidWithHttpInfo(assetModelId, tenantId, region, modelEdit,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Model',) as Model;
    
    }
    return Future<Model>.value();
  }

  /// Gets the effective permissions for the current user
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the effective permissions for the current user.<br/>Return Type: <b>UserPermissions</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Response> modelsPermissionsByAssetmodelidAndTenantidWithHttpInfo(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/Permissions"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the effective permissions for the current user
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the effective permissions for the current user.<br/>Return Type: <b>UserPermissions</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<UserPermissions> modelsPermissionsByAssetmodelidAndTenantid(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    final response = await modelsPermissionsByAssetmodelidAndTenantidWithHttpInfo(assetModelId, tenantId, region,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'UserPermissions',) as UserPermissions;
    
    }
    return Future<UserPermissions>.value();
  }

  /// Creates a new Model for the given Asset
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Creates a new Model for the given Asset.<br/>The ability to create Models may be limited by access level.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ModelCreate] modelCreate (required):
  Future<Response> modelsPostByTenantidWithHttpInfo(String tenantId, String region, ModelCreate modelCreate,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (modelCreate == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelCreate');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = modelCreate;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Creates a new Model for the given Asset
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Creates a new Model for the given Asset.<br/>The ability to create Models may be limited by access level.<br/>Return Type: <b>Model</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [ModelCreate] modelCreate (required):
  Future<Model> modelsPostByTenantid(String tenantId, String region, ModelCreate modelCreate,) async {
    final response = await modelsPostByTenantidWithHttpInfo(tenantId, region, modelCreate,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Model',) as Model;
    
    }
    return Future<Model>.value();
  }

  /// Requeues a model for processing and import
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Requeues a model for processing and import.<br/>Return Type: <b>boolean</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model ID to requeue
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> modelsReprocessByAssetmodelidAndTenantidWithHttpInfo(int assetModelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/Reprocess()"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Requeues a model for processing and import
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Requeues a model for processing and import.<br/>Return Type: <b>boolean</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///   The model ID to requeue
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<bool> modelsReprocessByAssetmodelidAndTenantid(int assetModelId, String tenantId, String region,) async {
    final response = await modelsReprocessByAssetmodelidAndTenantidWithHttpInfo(assetModelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'bool',) as bool;
    
    }
    return Future<bool>.value();
  }

  /// Revokes a user from the given role on the model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Revokes a user from the given role on the model.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [InlineObject7] inlineObject7 (required):
  Future<Response> modelsRevokeByTenantidAndAssetmodelidWithHttpInfo(String tenantId, int assetModelId, String region, InlineObject7 inlineObject7,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (inlineObject7 == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: inlineObject7');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/Roles.Revoke"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody = inlineObject7;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['application/json'];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Revokes a user from the given role on the model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Revokes a user from the given role on the model.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [InlineObject7] inlineObject7 (required):
  Future<void> modelsRevokeByTenantidAndAssetmodelid(String tenantId, int assetModelId, String region, InlineObject7 inlineObject7,) async {
    final response = await modelsRevokeByTenantidAndAssetmodelidWithHttpInfo(tenantId, assetModelId, region, inlineObject7,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
  }

  /// Gets the roles for the given Model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the roles for the given Model.<br/>Return Type: <b>ODataListResponseOfRole</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> modelsRolesByAssetmodelidAndTenantidWithHttpInfo(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({AssetModelId})/Roles"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the roles for the given Model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the roles for the given Model.<br/>Return Type: <b>ODataListResponseOfRole</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfRole> modelsRolesByAssetmodelidAndTenantid(int assetModelId, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await modelsRolesByAssetmodelidAndTenantidWithHttpInfo(assetModelId, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfRole',) as ODataListResponseOfRole;
    
    }
    return Future<ODataListResponseOfRole>.value();
  }

  /// Supercede an existing model with a new version
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Supercede an existing model with a new version.<br/>Return Type: <b>FileUploadResult</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///   The ID of the model to supercede.
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   A model file in the correct format (IFC / IFCZip / Zip)
  ///
  /// * [String] revision:
  ///   A version identifier for the model.
  ///
  /// * [String] status:
  ///   A status identifier for the model
  ///
  /// * [int] modelId:
  ///   The ID of the model to be populated with the data. If not defined, a new model will be created.
  ///
  /// * [String] originalFilename:
  ///   The original filename of the model, for zipped models
  Future<Response> modelsSupercedeByKeyAndTenantidWithHttpInfo(int key, String tenantId, String region, MultipartFile file, { String revision, String status, int modelId, String originalFilename, }) async {
    // Verify required params are set.
    if (key == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: key');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }
    if (file == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: file');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Models({key})/Supercede()"
      .replaceAll('{key}', key.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>['multipart/form-data'];

    bool hasFields = false;
    final mp = MultipartRequest('POST', Uri.parse(path));
    if (file != null) {
      hasFields = true;
      mp.fields[r'file'] = file.field;
      mp.files.add(file);
    }
    if (revision != null) {
      hasFields = true;
      mp.fields[r'revision'] = parameterToString(revision);
    }
    if (status != null) {
      hasFields = true;
      mp.fields[r'status'] = parameterToString(status);
    }
    if (modelId != null) {
      hasFields = true;
      mp.fields[r'modelId'] = parameterToString(modelId);
    }
    if (originalFilename != null) {
      hasFields = true;
      mp.fields[r'originalFilename'] = parameterToString(originalFilename);
    }
    if (hasFields) {
      postBody = mp;
    }

    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Supercede an existing model with a new version
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Supercede an existing model with a new version.<br/>Return Type: <b>FileUploadResult</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] key (required):
  ///   The ID of the model to supercede.
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [MultipartFile] file (required):
  ///   A model file in the correct format (IFC / IFCZip / Zip)
  ///
  /// * [String] revision:
  ///   A version identifier for the model.
  ///
  /// * [String] status:
  ///   A status identifier for the model
  ///
  /// * [int] modelId:
  ///   The ID of the model to be populated with the data. If not defined, a new model will be created.
  ///
  /// * [String] originalFilename:
  ///   The original filename of the model, for zipped models
  Future<FileUploadResult> modelsSupercedeByKeyAndTenantid(int key, String tenantId, String region, MultipartFile file, { String revision, String status, int modelId, String originalFilename, }) async {
    final response = await modelsSupercedeByKeyAndTenantidWithHttpInfo(key, tenantId, region, file,  revision: revision, status: status, modelId: modelId, originalFilename: originalFilename, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'FileUploadResult',) as FileUploadResult;
    
    }
    return Future<FileUploadResult>.value();
  }
}
