//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class SchedulesApi {
  SchedulesApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Get Schedules schedule by assetmodelid, schedulename and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Schedule</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] scheduleName (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Response> schedulesGetScheduleByAssetmodelidAndSchedulenameAndTenantidWithHttpInfo(int assetModelId, String scheduleName, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (scheduleName == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: scheduleName');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Schedules({AssetModelId},'{ScheduleName}')"
      .replaceAll('{AssetModelId}', assetModelId.toString())
      .replaceAll('{ScheduleName}', scheduleName)
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Schedules schedule by assetmodelid, schedulename and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>Schedule</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] scheduleName (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  Future<Schedule> schedulesGetScheduleByAssetmodelidAndSchedulenameAndTenantid(int assetModelId, String scheduleName, String tenantId, String region, { String dollarExpand, String dollarSelect, }) async {
    final response = await schedulesGetScheduleByAssetmodelidAndSchedulenameAndTenantidWithHttpInfo(assetModelId, scheduleName, tenantId, region,  dollarExpand: dollarExpand, dollarSelect: dollarSelect, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Schedule',) as Schedule;
    
    }
    return Future<Schedule>.value();
  }

  /// Get Schedules schedule rows by tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ODataListResponseOfRow</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] scheduleName (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> schedulesGetScheduleRowsByTenantidWithHttpInfo(int assetModelId, String scheduleName, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (assetModelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetModelId');
    }
    if (scheduleName == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: scheduleName');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Schedules({assetModelId},{scheduleName})/Rows"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }
      queryParams.addAll(_convertParametersForCollectionFormat('', 'AssetModelId', assetModelId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'ScheduleName', scheduleName));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Schedules schedule rows by tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>ODataListResponseOfRow</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetModelId (required):
  ///
  /// * [String] scheduleName (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfRow> schedulesGetScheduleRowsByTenantid(int assetModelId, String scheduleName, String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await schedulesGetScheduleRowsByTenantidWithHttpInfo(assetModelId, scheduleName, tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfRow',) as ODataListResponseOfRow;
    
    }
    return Future<ODataListResponseOfRow>.value();
  }

  /// Returns the EntitySet Schedules
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Schedules.<br/>Return Type: <b>ODataListResponseOfSchedule</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<Response> schedulesGetSchedulesByTenantidWithHttpInfo(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Schedules"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    if (dollarExpand != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$expand', dollarExpand));
    }
    if (dollarFilter != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$filter', dollarFilter));
    }
    if (dollarSelect != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$select', dollarSelect));
    }
    if (dollarOrderby != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$orderby', dollarOrderby));
    }
    if (dollarTop != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$top', dollarTop));
    }
    if (dollarSkip != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$skip', dollarSkip));
    }
    if (dollarCount != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('', '\$count', dollarCount));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Returns the EntitySet Schedules
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Returns the EntitySet Schedules.<br/>Return Type: <b>ODataListResponseOfSchedule</b><br/>For more information about OData responses <a href='https://www.odata.org/getting-started/understand-odata-in-6-steps/'>link</a>.<br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [String] dollarExpand:
  ///   Expands related entities inline.
  ///
  /// * [String] dollarFilter:
  ///   Filters the results, based on a Boolean condition.
  ///
  /// * [String] dollarSelect:
  ///   Selects which properties to include in the response.
  ///
  /// * [String] dollarOrderby:
  ///   Sorts the results.
  ///
  /// * [int] dollarTop:
  ///   Returns only the first n results.
  ///
  /// * [int] dollarSkip:
  ///   Skips the first n results.
  ///
  /// * [bool] dollarCount:
  ///   Includes a count of the matching results in the response.
  Future<ODataListResponseOfSchedule> schedulesGetSchedulesByTenantid(String tenantId, String region, { String dollarExpand, String dollarFilter, String dollarSelect, String dollarOrderby, int dollarTop, int dollarSkip, bool dollarCount, }) async {
    final response = await schedulesGetSchedulesByTenantidWithHttpInfo(tenantId, region,  dollarExpand: dollarExpand, dollarFilter: dollarFilter, dollarSelect: dollarSelect, dollarOrderby: dollarOrderby, dollarTop: dollarTop, dollarSkip: dollarSkip, dollarCount: dollarCount, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'ODataListResponseOfSchedule',) as ODataListResponseOfSchedule;
    
    }
    return Future<ODataListResponseOfSchedule>.value();
  }

  /// Post Schedules import schedule by modelid, schedule and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] schedule (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> schedulesImportScheduleByModelidAndScheduleAndTenantidWithHttpInfo(int modelId, String schedule, String tenantId, String region,) async {
    // Verify required params are set.
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (schedule == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: schedule');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/Schedules/Import(AssetModelId={modelId},ScheduleName='{schedule}')"
      .replaceAll('{modelId}', modelId.toString())
      .replaceAll('{schedule}', schedule)
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Schedules import schedule by modelid, schedule and tenantid
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] schedule (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Object> schedulesImportScheduleByModelidAndScheduleAndTenantid(int modelId, String schedule, String tenantId, String region,) async {
    final response = await schedulesImportScheduleByModelidAndScheduleAndTenantidWithHttpInfo(modelId, schedule, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Object',) as Object;
    
    }
    return Future<Object>.value();
  }
}
