//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class StatsApi {
  StatsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Lists the plan allowances and current consumpttion for a tenant's app
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lists the plan allowances and current consumpttion for a tenant's app.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> statsMeteredResourcesWithHttpInfo(String tenantId, String region,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/stats/planAllowances"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Lists the plan allowances and current consumpttion for a tenant's app
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Lists the plan allowances and current consumpttion for a tenant's app.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Map<String, IMeteredResource>> statsMeteredResources(String tenantId, String region,) async {
    final response = await statsMeteredResourcesWithHttpInfo(tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return Map<String, IMeteredResource>.from(await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Map<String, IMeteredResource>'),);

    }
    return Future<Map<String, IMeteredResource>>.value();
  }

  /// Provides details of the permitted rate limits for tenant's app and user
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Provides details of the permitted rate limits for tenant's app and user.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> statsRateLimitsWithHttpInfo(String tenantId, String region,) async {
    // Verify required params are set.
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/stats/rateLimits"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Provides details of the permitted rate limits for tenant's app and user
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Provides details of the permitted rate limits for tenant's app and user.<br/>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Map<String, QuotaStatus>> statsRateLimits(String tenantId, String region,) async {
    final response = await statsRateLimitsWithHttpInfo(tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return Map<String, QuotaStatus>.from(await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Map<String, QuotaStatus>'),);

    }
    return Future<Map<String, QuotaStatus>>.value();
  }
}
