//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class ThumbnailsApi {
  ThumbnailsApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Get Thumbnails asset thumbnail
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> thumbnailsGetAssetThumbnailWithHttpInfo(int assetId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/thumbnails/asset/{assetId}"
      .replaceAll('{assetId}', assetId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Get Thumbnails asset thumbnail
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> thumbnailsGetAssetThumbnail(int assetId, String tenantId, String region,) async {
    final response = await thumbnailsGetAssetThumbnailWithHttpInfo(assetId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Post Thumbnails asset thumbnail
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> thumbnailsPostAssetThumbnailWithHttpInfo(int assetId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/thumbnails/asset/{assetId}"
      .replaceAll('{assetId}', assetId.toString())
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'POST',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Post Thumbnails asset thumbnail
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Return Type: <b></b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Object> thumbnailsPostAssetThumbnail(int assetId, String tenantId, String region,) async {
    final response = await thumbnailsPostAssetThumbnailWithHttpInfo(assetId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'Object',) as Object;
    
    }
    return Future<Object>.value();
  }
}
