//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;


class WexbimApi {
  WexbimApi([ApiClient apiClient]) : apiClient = apiClient ?? defaultApiClient;

  final ApiClient apiClient;

  /// Gets the pre-generated complete wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated complete wexbim geometry stream for a model.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetCompleteWithHttpInfo(int assetId, int modelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/complete"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the pre-generated complete wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated complete wexbim geometry stream for a model.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetComplete(int assetId, int modelId, String tenantId, String region,) async {
    final response = await wexbimGetCompleteWithHttpInfo(assetId, modelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets the pre-generated components wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated components wexbim geometry stream for a model.<br/>E.g. Fixtures / Furniture, mechnical, electrical and engineering. Excludes the Envelope and Doors, windows and spaces.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetComponentsWithHttpInfo(int assetId, int modelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/components"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the pre-generated components wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated components wexbim geometry stream for a model.<br/>E.g. Fixtures / Furniture, mechnical, electrical and engineering. Excludes the Envelope and Doors, windows and spaces.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetComponents(int assetId, int modelId, String tenantId, String region,) async {
    final response = await wexbimGetComponentsWithHttpInfo(assetId, modelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets a dynamically generated geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets a dynamically generated geometry stream for a model.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The id of asset the model belongs to
  ///
  /// * [int] modelId (required):
  ///   The id of the model
  ///
  /// * [List<String>] included (required):
  ///   The IFC types to include (hierarchical)
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [List<String>] excluded:
  ///   The IFC types to exclude (hierarchical)
  Future<Response> wexbimGetDynamicWithHttpInfo(int assetId, int modelId, List<String> included, String tenantId, String region, { List<String> excluded, }) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (included == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: included');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/dynamic"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));
      queryParams.addAll(_convertParametersForCollectionFormat('csv', 'included', included));
    if (excluded != null) {
      queryParams.addAll(_convertParametersForCollectionFormat('csv', 'excluded', excluded));
    }

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets a dynamically generated geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets a dynamically generated geometry stream for a model.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The id of asset the model belongs to
  ///
  /// * [int] modelId (required):
  ///   The id of the model
  ///
  /// * [List<String>] included (required):
  ///   The IFC types to include (hierarchical)
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  ///
  /// * [List<String>] excluded:
  ///   The IFC types to exclude (hierarchical)
  Future<MultipartFile> wexbimGetDynamic(int assetId, int modelId, List<String> included, String tenantId, String region, { List<String> excluded, }) async {
    final response = await wexbimGetDynamicWithHttpInfo(assetId, modelId, included, tenantId, region,  excluded: excluded, );
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets the pre-generated building envelope wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated building envelope wexbim geometry stream for a model.<br/>E.g. The building fabric and external envelope.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The asset identifier.
  ///
  /// * [int] modelId (required):
  ///   The model identifier.
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetEnvelopeWithHttpInfo(int assetId, int modelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/envelope"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the pre-generated building envelope wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated building envelope wexbim geometry stream for a model.<br/>E.g. The building fabric and external envelope.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The asset identifier.
  ///
  /// * [int] modelId (required):
  ///   The model identifier.
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetEnvelope(int assetId, int modelId, String tenantId, String region,) async {
    final response = await wexbimGetEnvelopeWithHttpInfo(assetId, modelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets the building envelope geometry cut plane. This can be used to cap the holes after clipping.
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the building envelope geometry cut plane. This can be used to cap the holes after clipping..<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [double] bottom (required):
  ///
  /// * [double] top (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetEnvelopeCutWithHttpInfo(int assetId, int modelId, double bottom, double top, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (bottom == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: bottom');
    }
    if (top == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: top');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/envelopecut"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'bottom', bottom));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'top', top));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the building envelope geometry cut plane. This can be used to cap the holes after clipping.
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the building envelope geometry cut plane. This can be used to cap the holes after clipping..<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [double] bottom (required):
  ///
  /// * [double] top (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetEnvelopeCut(int assetId, int modelId, double bottom, double top, String tenantId, String region,) async {
    final response = await wexbimGetEnvelopeCutWithHttpInfo(assetId, modelId, bottom, top, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets the a cutplane across the envelope for up to 6 cut planes.
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the a cutplane across the envelope for up to 6 cut planes..<br/>Used to cap voids in the envelope when employing sections / section boxes.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [List<double>] planes (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetEnvelopeFreeCutWithHttpInfo(int assetId, int modelId, List<double> planes, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (planes == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: planes');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/envelopefreecut"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));
      queryParams.addAll(_convertParametersForCollectionFormat('csv', 'planes', planes));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the a cutplane across the envelope for up to 6 cut planes.
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the a cutplane across the envelope for up to 6 cut planes..<br/>Used to cap voids in the envelope when employing sections / section boxes.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [List<double>] planes (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetEnvelopeFreeCut(int assetId, int modelId, List<double> planes, String tenantId, String region,) async {
    final response = await wexbimGetEnvelopeFreeCutWithHttpInfo(assetId, modelId, planes, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets the pre-generated Site wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated Site wexbim geometry stream for a model.<br/>E.g. The building fabric and external envelope.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The asset identifier.
  ///
  /// * [int] modelId (required):
  ///   The model identifier.
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetSiteWithHttpInfo(int assetId, int modelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/site"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the pre-generated Site wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated Site wexbim geometry stream for a model.<br/>E.g. The building fabric and external envelope.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   The asset identifier.
  ///
  /// * [int] modelId (required):
  ///   The model identifier.
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetSite(int assetId, int modelId, String tenantId, String region,) async {
    final response = await wexbimGetSiteWithHttpInfo(assetId, modelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets the pre-generated spatial wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated spatial wexbim geometry stream for a model.<br/>E.g. The Site, Zones, Spaces in a Facility.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   Asset ID
  ///
  /// * [int] modelId (required):
  ///   Model ID
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetSpatialStructureWithHttpInfo(int assetId, int modelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/spatial"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the pre-generated spatial wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated spatial wexbim geometry stream for a model.<br/>E.g. The Site, Zones, Spaces in a Facility.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///   Asset ID
  ///
  /// * [int] modelId (required):
  ///   Model ID
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetSpatialStructure(int assetId, int modelId, String tenantId, String region,) async {
    final response = await wexbimGetSpatialStructureWithHttpInfo(assetId, modelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }

  /// Gets the pre-generated doors/windows wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated doors/windows wexbim geometry stream for a model.<br/>E.g. The building fabric and external envelope.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Note: This method returns the HTTP [Response].
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<Response> wexbimGetWindowsAndDoorsWithHttpInfo(int assetId, int modelId, String tenantId, String region,) async {
    // Verify required params are set.
    if (assetId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: assetId');
    }
    if (modelId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: modelId');
    }
    if (tenantId == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: tenantId');
    }
    if (region == null) {
     throw ApiException(HttpStatus.badRequest, 'Missing required param: region');
    }

    // ignore: prefer_const_declarations
    final path = r"/{region}/aim/2.0/{tenantId}/wexbim/windowsdoors"
      .replaceAll('{tenantId}', tenantId)
      .replaceAll('{region}', region);

    // ignore: prefer_final_locals
    Object postBody;

    final queryParams = <QueryParam>[];
    final headerParams = <String, String>{};
    final formParams = <String, String>{};

      queryParams.addAll(_convertParametersForCollectionFormat('', 'assetId', assetId));
      queryParams.addAll(_convertParametersForCollectionFormat('', 'modelId', modelId));

    const authNames = <String>['oauth2'];
    const contentTypes = <String>[];


    return apiClient.invokeAPI(
      path,
      'GET',
      queryParams,
      postBody,
      headerParams,
      formParams,
      contentTypes.isEmpty ? null : contentTypes[0],
      authNames,
    );
  }

  /// Gets the pre-generated doors/windows wexbim geometry stream for a model
  ///
  /// <span style='font-size: 17px;'>Summary:</span>Gets the pre-generated doors/windows wexbim geometry stream for a model.<br/>E.g. The building fabric and external envelope.<br/>Return Type: <b>string</b><br/><br/>
  ///
  /// Parameters:
  ///
  /// * [int] assetId (required):
  ///
  /// * [int] modelId (required):
  ///
  /// * [String] tenantId (required):
  ///   The unique Tenant ID (UUID or Identifier string)
  ///
  /// * [String] region (required):
  ///   The data center region the data resides in
  Future<MultipartFile> wexbimGetWindowsAndDoors(int assetId, int modelId, String tenantId, String region,) async {
    final response = await wexbimGetWindowsAndDoorsWithHttpInfo(assetId, modelId, tenantId, region,);
    if (response.statusCode >= HttpStatus.badRequest) {
      throw ApiException(response.statusCode, await _decodeBodyBytes(response));
    }
    // When a remote server returns no body with a status of 204, we shall not decode it.
    // At the time of writing this, `dart:convert` will throw an "Unexpected end of input"
    // FormatException when trying to decode an empty string.
    if (response.body != null && response.statusCode != HttpStatus.noContent) {
      return await apiClient.deserializeAsync(await _decodeBodyBytes(response), 'MultipartFile',) as MultipartFile;
    
    }
    return Future<MultipartFile>.value();
  }
}
