//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;

class ApiClient {
  ApiClient({this.basePath = 'https://apis.xbim-dev.net'}) {
    // Setup authentications (key: authentication name, value: authentication).
    _authentications[r'oauth2'] = OAuth();
  }

  final String basePath;

  var _client = Client();

  /// Returns the current HTTP [Client] instance to use in this class.
  ///
  /// The return value is guaranteed to never be null.
  Client get client => _client;

  /// Requests to use a new HTTP [Client] in this class.
  ///
  /// If the [newClient] is null, an [ArgumentError] is thrown.
  set client(Client newClient) {
    if (newClient == null) {
      throw ArgumentError('New client instance cannot be null.');
    }
    _client = newClient;
  }

  final _defaultHeaderMap = <String, String>{};
  final _authentications = <String, Authentication>{};

  void addDefaultHeader(String key, String value) {
     _defaultHeaderMap[key] = value;
  }

  Map<String,String> get defaultHeaderMap => _defaultHeaderMap;

  /// Returns an unmodifiable [Map] of the authentications, since none should be added
  /// or deleted.
  Map<String, Authentication> get authentications => Map.unmodifiable(_authentications);

  T getAuthentication<T extends Authentication>(String name) {
    final authentication = _authentications[name];
    return authentication is T ? authentication : null;
  }

  // We don't use a Map<String, String> for queryParams.
  // If collectionFormat is 'multi', a key might appear multiple times.
  Future<Response> invokeAPI(
    String path,
    String method,
    List<QueryParam> queryParams,
    Object body,
    Map<String, String> headerParams,
    Map<String, String> formParams,
    String nullableContentType,
    List<String> authNames,
  ) async {
    _updateParamsForAuth(authNames, queryParams, headerParams);

    headerParams.addAll(_defaultHeaderMap);

    final urlEncodedQueryParams = queryParams
      .where((param) => param.value != null)
      .map((param) => '$param');

    final queryString = urlEncodedQueryParams.isNotEmpty
      ? '?${urlEncodedQueryParams.join('&')}'
      : '';

    final uri = Uri.parse('$basePath$path$queryString');

    if (nullableContentType != null) {
      headerParams['Content-Type'] = nullableContentType;
    }

    try {
      // Special case for uploading a single file which isn't a 'multipart/form-data'.
      if (
        body is MultipartFile && (nullableContentType == null ||
        !nullableContentType.toLowerCase().startsWith('multipart/form-data'))
      ) {
        final request = StreamedRequest(method, uri);
        request.headers.addAll(headerParams);
        request.contentLength = body.length;
        body.finalize().listen(
          request.sink.add,
          onDone: request.sink.close,
          // ignore: avoid_types_on_closure_parameters
          onError: (Object error, StackTrace trace) => request.sink.close(),
          cancelOnError: true,
        );
        final response = await _client.send(request);
        return Response.fromStream(response);
      }

      if (body is MultipartRequest) {
        final request = MultipartRequest(method, uri);
        request.fields.addAll(body.fields);
        request.files.addAll(body.files);
        request.headers.addAll(body.headers);
        request.headers.addAll(headerParams);
        final response = await _client.send(request);
        return Response.fromStream(response);
      }

      final msgBody = nullableContentType == 'application/x-www-form-urlencoded'
        ? formParams
        : await serializeAsync(body);
      final nullableHeaderParams = headerParams.isEmpty ? null : headerParams;

      switch(method) {
        case 'POST': return await _client.post(uri, headers: nullableHeaderParams, body: msgBody,);
        case 'PUT': return await _client.put(uri, headers: nullableHeaderParams, body: msgBody,);
        case 'DELETE': return await _client.delete(uri, headers: nullableHeaderParams, body: msgBody,);
        case 'PATCH': return await _client.patch(uri, headers: nullableHeaderParams, body: msgBody,);
        case 'HEAD': return await _client.head(uri, headers: nullableHeaderParams,);
        case 'GET': return await _client.get(uri, headers: nullableHeaderParams,);
      }
    } on SocketException catch (e, trace) {
      throw ApiException.withInner(HttpStatus.badRequest, 'Socket operation failed: $method $path', e, trace,);
    } on TlsException catch (e, trace) {
      throw ApiException.withInner(HttpStatus.badRequest, 'TLS/SSL communication failed: $method $path', e, trace,);
    } on IOException catch (e, trace) {
      throw ApiException.withInner(HttpStatus.badRequest, 'I/O operation failed: $method $path', e, trace,);
    } on ClientException catch (e, trace) {
      throw ApiException.withInner(HttpStatus.badRequest, 'HTTP connection failed: $method $path', e, trace,);
    } on Exception catch (e, trace) {
      throw ApiException.withInner(HttpStatus.badRequest, 'Exception occurred: $method $path', e, trace,);
    }

    throw ApiException(HttpStatus.badRequest, 'Invalid HTTP operation: $method $path',);
  }

  Future<dynamic> deserializeAsync(String json, String targetType, {bool growable}) async =>
    // ignore: deprecated_member_use_from_same_package
    deserialize(json, targetType, growable: growable);

  @Deprecated('Scheduled for removal in OpenAPI Generator 6.x. Use deserializeAsync() instead.')
  dynamic deserialize(String json, String targetType, {bool growable}) {
    // Remove all spaces. Necessary for regular expressions as well.
    targetType = targetType.replaceAll(' ', ''); // ignore: parameter_assignments

    // If the expected target type is String, nothing to do...
    return targetType == 'String'
      ? json
      : _deserialize(jsonDecode(json), targetType, growable: growable == true);
  }

  // ignore: deprecated_member_use_from_same_package
  Future<String> serializeAsync(Object value) async => serialize(value);

  @Deprecated('Scheduled for removal in OpenAPI Generator 6.x. Use serializeAsync() instead.')
  String serialize(Object value) => value == null ? '' : json.encode(value);

  /// Update query and header parameters based on authentication settings.
  /// @param authNames The authentications to apply
  void _updateParamsForAuth(
    List<String> authNames,
    List<QueryParam> queryParams,
    Map<String, String> headerParams,
  ) {
    for(final authName in authNames) {
      final auth = _authentications[authName];
      if (auth == null) {
        throw ArgumentError('Authentication undefined: $authName');
      }
      auth.applyToParams(queryParams, headerParams);
    }
  }

  static dynamic _deserialize(dynamic value, String targetType, {bool growable}) {
    try {
      switch (targetType) {
        case 'String':
          return value is String ? value : value.toString();
        case 'int':
          return value is int ? value : int.parse('$value');
        case 'double':
          return value is double ? value : double.parse('$value');
        case 'bool':
          if (value is bool) {
            return value;
          }
          final valueString = '$value'.toLowerCase();
          return valueString == 'true' || valueString == '1';
        case 'Application':
          return Application.fromJson(value);
        case 'AssemblyDiagnostics':
          return AssemblyDiagnostics.fromJson(value);
        case 'AssemblyInfo':
          return AssemblyInfo.fromJson(value);
        case 'AssemblyItem':
          return AssemblyItem.fromJson(value);
        case 'Asset':
          return Asset.fromJson(value);
        case 'AssetCreate':
          return AssetCreate.fromJson(value);
        case 'AssetEdit':
          return AssetEdit.fromJson(value);
        case 'AssetSegment':
          return AssetSegment.fromJson(value);
        case 'AttributeDefinition':
          return AttributeDefinition.fromJson(value);
        case 'AttributeDefinitionCreate':
          return AttributeDefinitionCreate.fromJson(value);
        case 'AttributeDefinitionEdit':
          return AttributeDefinitionEdit.fromJson(value);
        case 'AttributeDefinitionEntity':
          return AttributeDefinitionEntity.fromJson(value);
        case 'AttributeValue':
          return AttributeValue.fromJson(value);
        case 'AttributeValueEntity':
          return AttributeValueEntity.fromJson(value);
        case 'Cell':
          return Cell.fromJson(value);
        case 'ClassificationNode':
          return ClassificationNode.fromJson(value);
        case 'ColumnDefinition':
          return ColumnDefinition.fromJson(value);
        case 'ComplexValueBase':
          return ComplexValueBase.fromJson(value);
        case 'Component':
          return Component.fromJson(value);
        case 'ComponentCreate':
          return ComponentCreate.fromJson(value);
        case 'ComponentEdit':
          return ComponentEdit.fromJson(value);
        case 'ComponentInfo':
          return ComponentInfo.fromJson(value);
        case 'ComponentType':
          return ComponentType.fromJson(value);
        case 'ComponentTypeInfo':
          return ComponentTypeInfo.fromJson(value);
        case 'Contact':
          return Contact.fromJson(value);
        case 'ContactEntity':
          return ContactEntity.fromJson(value);
        case 'ContactInfo':
          return ContactInfo.fromJson(value);
        case 'DbUpdate':
          return DbUpdate.fromJson(value);
        case 'Document':
          return Document.fromJson(value);
        case 'DocumentCreate':
          return DocumentCreate.fromJson(value);
        case 'DocumentEdit':
          return DocumentEdit.fromJson(value);
        case 'DocumentInfo':
          return DocumentInfo.fromJson(value);
        case 'Entity':
          return Entity.fromJson(value);
        case 'EntityBase':
          return EntityBase.fromJson(value);
        case 'EntityContact':
          return EntityContact.fromJson(value);
        case 'EntityCreate':
          return EntityCreate.fromJson(value);
        case 'EntityEdit':
          return EntityEdit.fromJson(value);
        case 'EntityMappingInfo':
          return EntityMappingInfo.fromJson(value);
        case 'EntityMatchDescriptor':
          return EntityMatchDescriptor.fromJson(value);
        case 'EntityMatchInfo':
          return EntityMatchInfo.fromJson(value);
        case 'EntityRef':
          return EntityRef.fromJson(value);
        case 'Facility':
          return Facility.fromJson(value);
        case 'FacilityInfo':
          return FacilityInfo.fromJson(value);
        case 'FileUploadResult':
          return FileUploadResult.fromJson(value);
        case 'Footprint':
          return Footprint.fromJson(value);
        case 'IMeteredResource':
          return IMeteredResource.fromJson(value);
        case 'IfcType':
          return IfcType.fromJson(value);
        case 'InlineObject2':
          return InlineObject2.fromJson(value);
        case 'InlineObject3':
          return InlineObject3.fromJson(value);
        case 'InlineObject4':
          return InlineObject4.fromJson(value);
        case 'InlineObject5':
          return InlineObject5.fromJson(value);
        case 'InlineObject6':
          return InlineObject6.fromJson(value);
        case 'InlineObject7':
          return InlineObject7.fromJson(value);
        case 'Issue':
          return Issue.fromJson(value);
        case 'IssueInfo':
          return IssueInfo.fromJson(value);
        case 'Job':
          return Job.fromJson(value);
        case 'JobCreate':
          return JobCreate.fromJson(value);
        case 'JobEdit':
          return JobEdit.fromJson(value);
        case 'JobInfo':
          return JobInfo.fromJson(value);
        case 'Level':
          return Level.fromJson(value);
        case 'LevelCreate':
          return LevelCreate.fromJson(value);
        case 'LevelEdit':
          return LevelEdit.fromJson(value);
        case 'LevelInfo':
          return LevelInfo.fromJson(value);
        case 'MappingMessageInfo':
          return MappingMessageInfo.fromJson(value);
        case 'MappingProperties':
          return MappingProperties.fromJson(value);
        case 'MemberPermission':
          return MemberPermission.fromJson(value);
        case 'MemberRole':
          return MemberRole.fromJson(value);
        case 'Model':
          return Model.fromJson(value);
        case 'ModelCreate':
          return ModelCreate.fromJson(value);
        case 'ModelEdit':
          return ModelEdit.fromJson(value);
        case 'ModelInfo':
          return ModelInfo.fromJson(value);
        case 'ModelMapping':
          return ModelMapping.fromJson(value);
        case 'ModelMappingInfo':
          return ModelMappingInfo.fromJson(value);
        case 'ModelMappingReport':
          return ModelMappingReport.fromJson(value);
        case 'ODataListResponseOfApplication':
          return ODataListResponseOfApplication.fromJson(value);
        case 'ODataListResponseOfAssemblyDiagnostics':
          return ODataListResponseOfAssemblyDiagnostics.fromJson(value);
        case 'ODataListResponseOfAssemblyItem':
          return ODataListResponseOfAssemblyItem.fromJson(value);
        case 'ODataListResponseOfAsset':
          return ODataListResponseOfAsset.fromJson(value);
        case 'ODataListResponseOfAttributeDefinition':
          return ODataListResponseOfAttributeDefinition.fromJson(value);
        case 'ODataListResponseOfAttributeDefinitionEntity':
          return ODataListResponseOfAttributeDefinitionEntity.fromJson(value);
        case 'ODataListResponseOfAttributeValue':
          return ODataListResponseOfAttributeValue.fromJson(value);
        case 'ODataListResponseOfComplexValueBase':
          return ODataListResponseOfComplexValueBase.fromJson(value);
        case 'ODataListResponseOfComponent':
          return ODataListResponseOfComponent.fromJson(value);
        case 'ODataListResponseOfComponentType':
          return ODataListResponseOfComponentType.fromJson(value);
        case 'ODataListResponseOfContact':
          return ODataListResponseOfContact.fromJson(value);
        case 'ODataListResponseOfDocument':
          return ODataListResponseOfDocument.fromJson(value);
        case 'ODataListResponseOfEntity':
          return ODataListResponseOfEntity.fromJson(value);
        case 'ODataListResponseOfEntityRef':
          return ODataListResponseOfEntityRef.fromJson(value);
        case 'ODataListResponseOfFacility':
          return ODataListResponseOfFacility.fromJson(value);
        case 'ODataListResponseOfIssue':
          return ODataListResponseOfIssue.fromJson(value);
        case 'ODataListResponseOfJob':
          return ODataListResponseOfJob.fromJson(value);
        case 'ODataListResponseOfLevel':
          return ODataListResponseOfLevel.fromJson(value);
        case 'ODataListResponseOfMemberPermission':
          return ODataListResponseOfMemberPermission.fromJson(value);
        case 'ODataListResponseOfModel':
          return ODataListResponseOfModel.fromJson(value);
        case 'ODataListResponseOfModelMapping':
          return ODataListResponseOfModelMapping.fromJson(value);
        case 'ODataListResponseOfModelMappingInfo':
          return ODataListResponseOfModelMappingInfo.fromJson(value);
        case 'ODataListResponseOfModelMappingReport':
          return ODataListResponseOfModelMappingReport.fromJson(value);
        case 'ODataListResponseOfResource':
          return ODataListResponseOfResource.fromJson(value);
        case 'ODataListResponseOfRole':
          return ODataListResponseOfRole.fromJson(value);
        case 'ODataListResponseOfRow':
          return ODataListResponseOfRow.fromJson(value);
        case 'ODataListResponseOfSchedule':
          return ODataListResponseOfSchedule.fromJson(value);
        case 'ODataListResponseOfSite':
          return ODataListResponseOfSite.fromJson(value);
        case 'ODataListResponseOfSpace':
          return ODataListResponseOfSpace.fromJson(value);
        case 'ODataListResponseOfSpare':
          return ODataListResponseOfSpare.fromJson(value);
        case 'ODataListResponseOfSystemItem':
          return ODataListResponseOfSystemItem.fromJson(value);
        case 'ODataListResponseOfZone':
          return ODataListResponseOfZone.fromJson(value);
        case 'ODataResponseOfBoolean':
          return ODataResponseOfBoolean.fromJson(value);
        case 'QuotaStatus':
          return QuotaStatus.fromJson(value);
        case 'RelatedEntity':
          return RelatedEntity.fromJson(value);
        case 'Resource':
          return Resource.fromJson(value);
        case 'ResourceInfo':
          return ResourceInfo.fromJson(value);
        case 'Role':
          return Role.fromJson(value);
        case 'RoleMember':
          return RoleMember.fromJson(value);
        case 'Row':
          return Row.fromJson(value);
        case 'Schedule':
          return Schedule.fromJson(value);
        case 'Site':
          return Site.fromJson(value);
        case 'Space':
          return Space.fromJson(value);
        case 'SpaceCreate':
          return SpaceCreate.fromJson(value);
        case 'SpaceEdit':
          return SpaceEdit.fromJson(value);
        case 'SpaceInfo':
          return SpaceInfo.fromJson(value);
        case 'Spare':
          return Spare.fromJson(value);
        case 'SpareCreate':
          return SpareCreate.fromJson(value);
        case 'SpareEdit':
          return SpareEdit.fromJson(value);
        case 'SpareInfo':
          return SpareInfo.fromJson(value);
        case 'SvgGenerationConfig':
          return SvgGenerationConfig.fromJson(value);
        case 'SvgStylingLayer':
          return SvgStylingLayer.fromJson(value);
        case 'SystemInfo':
          return SystemInfo.fromJson(value);
        case 'SystemItem':
          return SystemItem.fromJson(value);
        case 'UserPermissions':
          return UserPermissions.fromJson(value);
        case 'ValueContainer':
          return ValueContainer.fromJson(value);
        case 'Zone':
          return Zone.fromJson(value);
        case 'ZoneInfo':
          return ZoneInfo.fromJson(value);
        default:
          Match match;
          if (value is List && (match = _regList.firstMatch(targetType)) != null) {
            targetType = match[1]; // ignore: parameter_assignments
            return value
              .map<dynamic>((dynamic v) => _deserialize(v, targetType, growable: growable))
              .toList(growable: growable);
          }
          if (value is Set && (match = _regSet.firstMatch(targetType)) != null) {
            targetType = match[1]; // ignore: parameter_assignments
            return value
              .map<dynamic>((dynamic v) => _deserialize(v, targetType, growable: growable))
              .toSet();
          }
          if (value is Map && (match = _regMap.firstMatch(targetType)) != null) {
            targetType = match[1]; // ignore: parameter_assignments
            return Map<String, dynamic>.fromIterables(
              value.keys.cast<String>(),
              value.values.map<dynamic>((dynamic v) => _deserialize(v, targetType, growable: growable)),
            );
          }
      }
    } on Exception catch (error, trace) {
      throw ApiException.withInner(HttpStatus.internalServerError, 'Exception during deserialization.', error, trace,);
    }
    throw ApiException(HttpStatus.internalServerError, 'Could not find a suitable class for deserialization',);
  }

  static List<dynamic> listFromJson(dynamic json, {bool emptyIsNull, bool growable,}) =>
    json is List && json.isNotEmpty
      ? json.map(ApiClient.elementFromJson).toList(growable: true == growable)
      : true == emptyIsNull ? null : <dynamic>[];

  static dynamic elementFromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();
      return json;
    }
    return null;
  }

}

/// Primarily intended for use in an isolate.
class DeserializationMessage {
  const DeserializationMessage({
    @required this.json,
    @required this.targetType,
    this.growable,
  });

  /// The JSON value to deserialize.
  final String json;

  /// Target type to deserialize to.
  final String targetType;

  /// Whether to make deserialized lists or maps growable.
  final bool growable;
}

/// Primarily intended for use in an isolate.
Future<dynamic> deserializeAsync(DeserializationMessage message) async {
  // Remove all spaces. Necessary for regular expressions as well.
  final targetType = message.targetType.replaceAll(' ', '');

  // If the expected target type is String, nothing to do...
  return targetType == 'String'
    ? message.json
    : ApiClient._deserialize(
        jsonDecode(message.json),
        targetType,
        growable: message.growable == true,
      );
}

/// Primarily intended for use in an isolate.
Future<String> serializeAsync(Object value) async => value == null ? '' : json.encode(value);
