//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;

class DocumentEdit {
  /// Returns a new [DocumentEdit] instance.
  DocumentEdit({
    this.url,
    this.location,
    this.itemReference,
    this.scope,
    this.revision,
    this.purpose,
    this.intendedUse,
    this.name,
    this.description,
    this.externalObjectType,
  });

  /// The Url of the document. Prefer Location over setting the URL
  String url;

  /// Location, where the external source (classification, document or library).   For externally hosted documents normally given as an URL location string. For documents hosted in Flex, use the value 'Flex',   and provide the Flex 'fileId' in the Item Reference
  String location;

  /// Identifier for the referenced item in the external source (classification, document or library)  For documents hosted in Flex this should be the fileId
  String itemReference;

  /// Scope for this document.
  String scope;

  /// Document revision designation
  String revision;

  /// Purpose for this document.
  String purpose;

  /// Intended Use for this document.
  String intendedUse;

  /// The name of the entity
  String name;

  /// Optional Description of the document
  String description;

  /// A system identifier of the type of entity
  String externalObjectType;

  @override
  bool operator ==(Object other) => identical(this, other) || other is DocumentEdit &&
     other.url == url &&
     other.location == location &&
     other.itemReference == itemReference &&
     other.scope == scope &&
     other.revision == revision &&
     other.purpose == purpose &&
     other.intendedUse == intendedUse &&
     other.name == name &&
     other.description == description &&
     other.externalObjectType == externalObjectType;

  @override
  int get hashCode =>
  // ignore: unnecessary_parenthesis
    (url == null ? 0 : url.hashCode) +
    (location == null ? 0 : location.hashCode) +
    (itemReference == null ? 0 : itemReference.hashCode) +
    (scope == null ? 0 : scope.hashCode) +
    (revision == null ? 0 : revision.hashCode) +
    (purpose == null ? 0 : purpose.hashCode) +
    (intendedUse == null ? 0 : intendedUse.hashCode) +
    (name == null ? 0 : name.hashCode) +
    (description == null ? 0 : description.hashCode) +
    (externalObjectType == null ? 0 : externalObjectType.hashCode);

  @override
  String toString() => 'DocumentEdit[url=$url, location=$location, itemReference=$itemReference, scope=$scope, revision=$revision, purpose=$purpose, intendedUse=$intendedUse, name=$name, description=$description, externalObjectType=$externalObjectType]';

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    if (url != null) {
      json[r'Url'] = url;
    }
    if (location != null) {
      json[r'Location'] = location;
    }
    if (itemReference != null) {
      json[r'ItemReference'] = itemReference;
    }
    if (scope != null) {
      json[r'Scope'] = scope;
    }
    if (revision != null) {
      json[r'Revision'] = revision;
    }
    if (purpose != null) {
      json[r'Purpose'] = purpose;
    }
    if (intendedUse != null) {
      json[r'IntendedUse'] = intendedUse;
    }
    if (name != null) {
      json[r'Name'] = name;
    }
    if (description != null) {
      json[r'Description'] = description;
    }
    if (externalObjectType != null) {
      json[r'ExternalObjectType'] = externalObjectType;
    }
    return json;
  }

  /// Returns a new [DocumentEdit] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static DocumentEdit fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();
      return DocumentEdit(
        url: mapValueOfType<String>(json, r'Url'),
        location: mapValueOfType<String>(json, r'Location'),
        itemReference: mapValueOfType<String>(json, r'ItemReference'),
        scope: mapValueOfType<String>(json, r'Scope'),
        revision: mapValueOfType<String>(json, r'Revision'),
        purpose: mapValueOfType<String>(json, r'Purpose'),
        intendedUse: mapValueOfType<String>(json, r'IntendedUse'),
        name: mapValueOfType<String>(json, r'Name'),
        description: mapValueOfType<String>(json, r'Description'),
        externalObjectType: mapValueOfType<String>(json, r'ExternalObjectType'),
      );
    }
    return null;
  }

  static List<DocumentEdit> listFromJson(dynamic json, {bool emptyIsNull, bool growable,}) =>
    json is List && json.isNotEmpty
      ? json.map(DocumentEdit.fromJson).toList(growable: true == growable)
      : true == emptyIsNull ? null : <DocumentEdit>[];

  static Map<String, DocumentEdit> mapFromJson(dynamic json) {
    final map = <String, DocumentEdit>{};
    if (json is Map && json.isNotEmpty) {
      json
        .cast<String, dynamic>()
        .forEach((key, dynamic value) => map[key] = DocumentEdit.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of DocumentEdit-objects as value to a dart map
  static Map<String, List<DocumentEdit>> mapListFromJson(dynamic json, {bool emptyIsNull, bool growable,}) {
    final map = <String, List<DocumentEdit>>{};
    if (json is Map && json.isNotEmpty) {
      json
        .cast<String, dynamic>()
        .forEach((key, dynamic value) {
          map[key] = DocumentEdit.listFromJson(
            value,
            emptyIsNull: emptyIsNull,
            growable: growable,
          );
        });
    }
    return map;
  }
}

