//
// AUTO-GENERATED FILE, DO NOT MODIFY!
//
// @dart=2.0

// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of openapi.api;

class ModelCreate {
  /// Returns a new [ModelCreate] instance.
  ModelCreate({
    this.assetId,
    @required this.name,
    @required this.revision,
    @required this.status,
    this.state,
    this.segmentName,
  });

  /// The Asset Identifier to Associate the model to
  int assetId;

  /// The name of the model.
  String name;

  /// The Revison of the model -e.g. P01
  String revision;

  /// The Status/Purpose of the model - e.g S1
  String status;

  /// Flag indicating the internal Flex status of the model
  ModelCreateStateEnum state;

  /// An optional SegmentName to associate the model with
  String segmentName;

  @override
  bool operator ==(Object other) => identical(this, other) || other is ModelCreate &&
     other.assetId == assetId &&
     other.name == name &&
     other.revision == revision &&
     other.status == status &&
     other.state == state &&
     other.segmentName == segmentName;

  @override
  int get hashCode =>
  // ignore: unnecessary_parenthesis
    (assetId == null ? 0 : assetId.hashCode) +
    (name == null ? 0 : name.hashCode) +
    (revision == null ? 0 : revision.hashCode) +
    (status == null ? 0 : status.hashCode) +
    (state == null ? 0 : state.hashCode) +
    (segmentName == null ? 0 : segmentName.hashCode);

  @override
  String toString() => 'ModelCreate[assetId=$assetId, name=$name, revision=$revision, status=$status, state=$state, segmentName=$segmentName]';

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    if (assetId != null) {
      json[r'AssetId'] = assetId;
    }
      json[r'Name'] = name;
      json[r'Revision'] = revision;
      json[r'Status'] = status;
    if (state != null) {
      json[r'State'] = state;
    }
    if (segmentName != null) {
      json[r'SegmentName'] = segmentName;
    }
    return json;
  }

  /// Returns a new [ModelCreate] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static ModelCreate fromJson(dynamic value) {
    if (value is Map) {
      final json = value.cast<String, dynamic>();
      return ModelCreate(
        assetId: mapValueOfType<int>(json, r'AssetId'),
        name: mapValueOfType<String>(json, r'Name'),
        revision: mapValueOfType<String>(json, r'Revision'),
        status: mapValueOfType<String>(json, r'Status'),
        state: ModelCreateStateEnum.fromJson(json[r'State']),
        segmentName: mapValueOfType<String>(json, r'SegmentName'),
      );
    }
    return null;
  }

  static List<ModelCreate> listFromJson(dynamic json, {bool emptyIsNull, bool growable,}) =>
    json is List && json.isNotEmpty
      ? json.map(ModelCreate.fromJson).toList(growable: true == growable)
      : true == emptyIsNull ? null : <ModelCreate>[];

  static Map<String, ModelCreate> mapFromJson(dynamic json) {
    final map = <String, ModelCreate>{};
    if (json is Map && json.isNotEmpty) {
      json
        .cast<String, dynamic>()
        .forEach((key, dynamic value) => map[key] = ModelCreate.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of ModelCreate-objects as value to a dart map
  static Map<String, List<ModelCreate>> mapListFromJson(dynamic json, {bool emptyIsNull, bool growable,}) {
    final map = <String, List<ModelCreate>>{};
    if (json is Map && json.isNotEmpty) {
      json
        .cast<String, dynamic>()
        .forEach((key, dynamic value) {
          map[key] = ModelCreate.listFromJson(
            value,
            emptyIsNull: emptyIsNull,
            growable: growable,
          );
        });
    }
    return map;
  }
}

/// Flag indicating the internal Flex status of the model
class ModelCreateStateEnum {
  /// Instantiate a new enum with the provided [value].
  const ModelCreateStateEnum._(this.value);

  /// The underlying value of this enum member.
  final String value;

  @override
  String toString() => value ?? '';

  String toJson() => value;

  static const active = ModelCreateStateEnum._(r'Active');
  static const hidden = ModelCreateStateEnum._(r'Hidden');
  static const archived = ModelCreateStateEnum._(r'Archived');

  /// List of all possible values in this [enum][ModelCreateStateEnum].
  static const values = <ModelCreateStateEnum>[
    active,
    hidden,
    archived,
  ];

  static ModelCreateStateEnum fromJson(dynamic value) =>
    ModelCreateStateEnumTypeTransformer().decode(value);

  static List<ModelCreateStateEnum> listFromJson(dynamic json, {bool emptyIsNull, bool growable,}) =>
    json is List && json.isNotEmpty
      ? json.map(ModelCreateStateEnum.fromJson).toList(growable: true == growable)
      : true == emptyIsNull ? null : <ModelCreateStateEnum>[];
}

/// Transformation class that can [encode] an instance of [ModelCreateStateEnum] to String,
/// and [decode] dynamic data back to [ModelCreateStateEnum].
class ModelCreateStateEnumTypeTransformer {
  factory ModelCreateStateEnumTypeTransformer() => _instance ??= const ModelCreateStateEnumTypeTransformer._();

  const ModelCreateStateEnumTypeTransformer._();

  String encode(ModelCreateStateEnum data) => data.value;

  /// Decodes a [dynamic value][data] to a ModelCreateStateEnum.
  ///
  /// If [allowNull] is true and the [dynamic value][data] cannot be decoded successfully,
  /// then null is returned. However, if [allowNull] is false and the [dynamic value][data]
  /// cannot be decoded successfully, then an [UnimplementedError] is thrown.
  ///
  /// The [allowNull] is very handy when an API changes and a new enum value is added or removed,
  /// and users are still using an old app with the old code.
  ModelCreateStateEnum decode(dynamic data, {bool allowNull}) {
    if (data != null) {
      switch (data.toString()) {
        case r'Active': return ModelCreateStateEnum.active;
        case r'Hidden': return ModelCreateStateEnum.hidden;
        case r'Archived': return ModelCreateStateEnum.archived;
        default:
          if (allowNull == false) {
            throw ArgumentError('Unknown enum value to decode: $data');
          }
      }
    }
    return null;
  }

  /// Singleton [ModelCreateStateEnumTypeTransformer] instance.
  static ModelCreateStateEnumTypeTransformer _instance;
}


